﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

namespace Syringe
{
    public class AMP : TemporaryBodyLiquid
    {
        public AMP()
        {
            this.Color = new Color(0.25f, 0.25f, 0.25f, 1f);
        }
        public override void OnEnterContainer(BloodContainer container)
        {
        }
        public override void OnEnterLimb(LimbBehaviour limb)
        {
            if (limb.SpeciesIdentity == "Android")
                return;
            limb.BreakingThreshold = 0f;

        }
        public override void OnExitContainer(BloodContainer container)
        {
        }
        public string ID = "Amputation Serum";
    }
    public class PAIN : TemporaryBodyLiquid
    {
        public PAIN()
        {
            this.Color = new Color(0.5f, 0.5f, 0.5f, 1f);
        }
        public override void OnEnterContainer(BloodContainer container)
        {
        }
        public override void OnEnterLimb(LimbBehaviour limb)
        {
            if (limb.SpeciesIdentity == "Android")
                return;
            limb.Person.PainLevel = 25.0f; // make this cooler

        }
        public override void OnExitContainer(BloodContainer container)
        {
        }
        public string ID = "Pain Poison";
    }
    public class GHOST : Blood //idk seems to work with this only?
    {
        public GHOST()
        {
            this.Color = new Color(0.95f, 0.95f, 0.95f, 0.25f);
        }
        public override void OnEnterContainer(BloodContainer container)
        {
        }
        public override void OnEnterLimb(LimbBehaviour limb)
        {
            if (limb.SpeciesIdentity == "Android")
                return;
            limb.GetComponent<SpriteRenderer>().color = new Color(0.95f, 0.95f, 0.95f, 0.05f);
            var Phys = limb.GetComponent<PhysicalBehaviour>();
            Phys.AbsorbsLasers = false;
            Phys.ForceNoCharge = true;
            limb.gameObject.AddComponent<GhostCollisionBehaviour>();
           // foreach (var col in limb.GetComponents<Collider2D>())
            //{
                //GameObject.Destroy(col);
            //}

        }
        public override void OnExitContainer(BloodContainer container)
        {
        }
        public string ID = "Pain Poison";
    }
    public class GhostCollisionBehaviour : MonoBehaviour
    {
        void OnCollisionEnter2D(Collision2D collision)
        {
            ModAPI.Notify(collision.gameObject.name); //find a better way to do this lol
            if (collision.gameObject.name == "Root" || collision.gameObject.name == "Ceiling" || collision.gameObject.name == "Left wall" || collision.gameObject.name == "Right wall")
            {
                ModAPI.Notify("Root no need for col");
            }
            else
            {
                ModAPI.Notify("disabled col");
                Physics2D.IgnoreCollision(collision.gameObject.GetComponent<Collider2D>(), gameObject.GetComponent<Collider2D>());
                
            }
            
        }
    }
    public class KNOCKOUT : TemporaryBodyLiquid
    {
        public KNOCKOUT()
        {
            this.Color = new Color(0.71f, 0.39f, 0.11f, 1f); //blah blah blah color 32 is more efficient, I just wanna copy and paste from the original
        }
        public override void OnEnterContainer(BloodContainer container)
        {
        }
        public override void OnEnterLimb(LimbBehaviour limb)
        {
            if (limb.SpeciesIdentity == "Android")
                return;
            limb.Person.Consciousness = 0.0f;
            if (limb.gameObject.name == "Head")
            {
                if (limb.gameObject.GetComponent<KnockoutBehaviour>() == null)
                {
                    limb.gameObject.AddComponent<KnockoutBehaviour>();
                }

            }

        }
        public override void OnExitContainer(BloodContainer container)
        {
        }
        public string ID = "Comatose Concoction";
    }
    public class KnockoutBehaviour : MonoBehaviour
    {
        public bool ShouldBeKnockedOut;
        public void Awake()
        {
            //ModAPI.Notify("AAAA");
            
        }
        public void Start()
        {
            //ModAPI.Notify("BBBB");
            //ShouldBeKnockedOut = true;
        }
        public void Update()
        {
            //if (ShouldBeKnockedOut == true)
            //{
                gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0.0f; //incredible performance
            //}

        }
    }
    //it was at this point I noticed an easier way to do the syinges/liquids (registering them within one block of code)
    public class ANTIKNOCKOUT : TemporaryBodyLiquid
    {
        public ANTIKNOCKOUT()
        {
            this.Color = new Color(0.29f, 0.61f, 0.89f, 1f);
        }
        public override void OnEnterContainer(BloodContainer container)
        {

        }
        public override void OnEnterLimb(LimbBehaviour limb)
        {

            if (limb.SpeciesIdentity == "Android")
                return;
            if(limb.gameObject.name == "Head")
            {
                if (limb.gameObject.GetComponent<KnockoutBehaviour>() == null)
                    return;
                //Mod
                UnityEngine.Object.Destroy(limb.gameObject.GetComponent<KnockoutBehaviour>());
                ModAPI.Notify("Destroyed!");
                
            }

        }
        public override void OnExitContainer(BloodContainer container)
        {
        }
        public string ID = "Pain Poison";
    }
    public class PAINKILL : TemporaryBodyLiquid
    {
        public PAINKILL()
        {
            this.Color = new Color(0.15f, 0.35f, 0.75f, 1f); //blah blah blah color 32 is more efficient, I just wanna copy and paste from the original
        }
        public override void OnEnterContainer(BloodContainer container)
        {
        }
        public override void OnEnterLimb(LimbBehaviour limb)
        {
            if (limb.SpeciesIdentity == "Android")
                return;
            limb.Person.ShockLevel = 0.0f;
            limb.Person.AdrenalineLevel = 1.0f;
            limb.Person.PainLevel = 0.0f;

            if (limb.gameObject.name == "Head")
            {
                if (limb.gameObject.GetComponent<PainKillBehaviour>() == null)
                {
                    limb.gameObject.AddComponent<PainKillBehaviour>();
                }

            }

        }
        public override void OnExitContainer(BloodContainer container)
        {
        }
        public string ID = "Liquid Painkillers";
    }
    public class PainKillBehaviour : MonoBehaviour
    {
        public void Awake()
        {
        }
        public void Start()
        {
        }
        public void Update()
        {
            if (gameObject.GetComponent<LimbBehaviour>().Health > 0)
            {
                gameObject.GetComponent<LimbBehaviour>().Person.PainLevel = 0.0f;
                gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel = 0.0f;
                gameObject.GetComponent<LimbBehaviour>().Person.AdrenalineLevel = 1.0f;
            }

        }
    }
    public class SUFFOCATION : TemporaryBodyLiquid
    {
        public SUFFOCATION()
        {
            this.Color = new Color(0.74f, 0.61f, 0.63f, 1f);
        }
        public override void OnEnterContainer(BloodContainer container)
        {

        }
        public override void OnEnterLimb(LimbBehaviour limb)
        {

            if (limb.SpeciesIdentity == "Android")
                return;
            if (limb.gameObject.name == "Head")
            {
                if (limb.gameObject.GetComponent<SuffocationBehaviour>() == null)
                {
                    limb.gameObject.AddComponent<SuffocationBehaviour>();
                }
            }

        }
        public override void OnExitContainer(BloodContainer container)
        {
        }
        public string ID = "Suffocation Serum";
    }
    public class SuffocationBehaviour : MonoBehaviour
    {
        public void Update()
        {
            var lb = gameObject.GetComponent<LimbBehaviour>();
            if (lb.IsConsideredAlive == true)
            {
                lb.Person.OxygenLevel = lb.Person.OxygenLevel - 0.0007f;
                lb.Person.Consciousness = lb.Person.Consciousness - 0.00025f;
                lb.Person.PainLevel = lb.Person.PainLevel + 0.0035f;
            }
            else
            {
                Destroy(gameObject.GetComponent<SuffocationBehaviour>());
            }
        }
    }
    public class GILLS : TemporaryBodyLiquid
    {
        public GILLS()
        {
            this.Color = new Color(0.502f, 0.773f, 0.871f, 1f);
        }
        public override void OnEnterContainer(BloodContainer container)
        {

        }
        public override void OnEnterLimb(LimbBehaviour limb)
        {

            if (limb.SpeciesIdentity == "Android")
                return;
            if (limb.gameObject.name == "Head")
            {
                if (limb.gameObject.GetComponent<GillsBehaviour>() == null)
                {
                    limb.gameObject.AddComponent<GillsBehaviour>();
                }
            }

        }
        public override void OnExitContainer(BloodContainer container)
        {
        }
        public string ID = "Fish Gills";
    }
    public class GillsBehaviour : MonoBehaviour
    {
        public void Update()
        {
            var lb = gameObject.GetComponent<LimbBehaviour>();
            var pb = gameObject.GetComponent<PhysicalBehaviour>();

            if (pb.Wetness > 0.0f)
            {
                if (lb.Person.OxygenLevel < 1.0f)
                {
                    lb.Person.OxygenLevel = lb.Person.OxygenLevel + 0.001f;
                }
            }
        }
    }
    public class ZCURE : TemporaryBodyLiquid
    {
        public ZCURE()
        {
            this.Color = new Color(0.25f, 075f, 0.35f);
        }
        public override void OnEnterContainer(BloodContainer container)
        {

        }
        public override void OnEnterLimb(LimbBehaviour limb)
        {

            if (limb.SpeciesIdentity == "Android")
                return;
            if(limb.IsZombie == true)
            {
                limb.IsZombie = false;
                limb.Numbness = 2.25f;
            }
            else
            {
                limb.Person.PainLevel = 5.0f;
                limb.Person.Consciousness = limb.Person.Consciousness - 0.075f;
            }
        }
        public override void OnExitContainer(BloodContainer container)
        {
        }
        public string ID = "Zombie Virus Anti-bodies";
    }
    public class INVINCE : TemporaryBodyLiquid
    {
        public INVINCE()
        {
            this.Color = new Color(1f, 1f, 1f, 1f);
        }
        public override void OnEnterContainer(BloodContainer container)
        {

        }
        public override void OnEnterLimb(LimbBehaviour limb)
        {

            if (limb.SpeciesIdentity == "Android")
                return;
            limb.gameObject.AddComponent<INVINCEBehaviour>();
        }
        public override void OnExitContainer(BloodContainer container)
        {
        }
        public string ID = "Invincibility Potion";
    }
    public class INVINCEBehaviour : MonoBehaviour
    {
        void Start()
        {
            var lb = gameObject.GetComponent<LimbBehaviour>();
            lb.BreakingThreshold = 500f;
            lb.RegenerationSpeed = 250f;
            lb.InitialHealth *= 1000f;
            lb.BaseStrength = 25f;
            lb.CirculationBehaviour.HealBleeding();
            lb.CirculationBehaviour.ImmuneToDamage = true;
            lb.CirculationBehaviour.BloodLossRateMultiplier = 0.0f;
        }
        void Update()
        {
            var lb = gameObject.GetComponent<LimbBehaviour>();
            lb.Health = lb.InitialHealth;
            lb.CirculationBehaviour.HealBleeding();
            lb.Person.Consciousness = 1.0f;
            lb.CirculationBehaviour.BloodFlow = 1.0f;
            //lb.CirculationBehaviour.BloodAmount = 1.0f;
        }
    }
    public class TEMP : TemporaryBodyLiquid
    {
        public TEMP()
        {
            this.Color = new Color(0.72f, 0.89f, 0.39f, 1f);
        }
        public override void OnEnterContainer(BloodContainer container)
        {

        }
        public override void OnEnterLimb(LimbBehaviour limb)
        {

            if (limb.SpeciesIdentity == "Android")
                return;

            limb.FreezingTemperature = -50f;
            limb.DiscomfortingHeatTemperature = 500f; //incredible job

            if (limb.gameObject.GetComponent<TempConstantBehaviour>() == null)
            {
                limb.gameObject.AddComponent<TempConstantBehaviour>();
            }

        }
        public override void OnExitContainer(BloodContainer container)
        {

        }
    }
    public class TempConstantBehaviour : MonoBehaviour
    {
        void Update()
        {
            var PB = gameObject.GetComponent<PhysicalBehaviour>();
            var LB = gameObject.GetComponent<LimbBehaviour>();
            PB.Temperature = 37f;
            LB.BodyTemperature = 37f;

        }
    }
}
