﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

namespace Syringe
{
    public class Mod
    {
        public static void Main()
        {
            //Epic Registry
            Liquid.Register("Amputation Serum", new AMP());
            Liquid.Register("Pain Poison", new PAIN());
            Liquid.Register("Ghosting Agent", new GHOST());
            Liquid.Register("Comatose Concoction", new KNOCKOUT());
            Liquid.Register("Comatose Antidote", new ANTIKNOCKOUT());
            Liquid.Register("Liquid Painkillers", new PAINKILL());
            Liquid.Register("Suffocation Serum", new SUFFOCATION());
            Liquid.Register("Fish Gills", new GILLS());
            Liquid.Register("Zombie Virus Anti-bodies", new ZCURE());
            Liquid.Register("Invincibility Potion", new INVINCE());
            Liquid.Register("Temperature Immunity", new TEMP());
            //Liquid.Register("Extreme Temperature Glands", new EXTEMP());


            //Registering Items
            ModAPI.Register(
            new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"),
                    NameOverride = "Blood Syringe",
                    NameToOrderByOverride = "!SkittleSyringe1",
                    DescriptionOverride = "Like the blood vial, but in a syringe",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb/BLOOD.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<BLOODSyringe>();
                        Instance.GetComponent<BLOODSyringe>().Finite = true; //not really needed but I like having it finite
                        Instance.GetComponent<BLOODSyringe>().TransferRate = 0.01f;
                    }
                }
            );
            ModAPI.Register(
            new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"),
                    NameOverride = "Amputation Syringe",
                    NameToOrderByOverride = "!SkittleSyringe2",
                    DescriptionOverride = "Makes easy amputations",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb/AMP.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<AMPSyringe>();
                        Instance.GetComponent<AMPSyringe>().Finite = true; //not really needed but I like having it finite
                        Instance.GetComponent<AMPSyringe>().TransferRate = 0.000001f;
                    }
                }
            );
            ModAPI.Register(
            new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //this kinda sucks
                    NameOverride = "Pain Syringe",
                    NameToOrderByOverride = "!SkittleSyringe3",
                    DescriptionOverride = "Causes extreme pain for a short while",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb/PAIN.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<PAINSyringe>();
                        Instance.GetComponent<PAINSyringe>().Finite = true;
                        Instance.GetComponent<PAINSyringe>().TransferRate = 0.01f;
                    }
                }
            );
            ModAPI.Register(
            new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"),
                    NameOverride = "Ghost Syringe",
                    NameToOrderByOverride = "!SkittleSyringe4",
                    DescriptionOverride = "Turns user into a Ghost, who can walk through surfaces (sorta)",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb/GHOST.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<GHOSTSyringe>();
                        Instance.GetComponent<GHOSTSyringe>().Finite = true;
                        Instance.GetComponent<GHOSTSyringe>().TransferRate = 0.01f;
                    }
                }
            );
            ModAPI.Register(
            new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"),
                    NameOverride = "Infinite Knockout Syringe",
                    NameToOrderByOverride = "!SkittleSyringe5",
                    DescriptionOverride = "Like the knockout syringe, but knocks them out until given an antidote",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb/KNOCK.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<KNOCKSyringe>();
                        Instance.GetComponent<KNOCKSyringe>().Finite = true;
                        Instance.GetComponent<KNOCKSyringe>().TransferRate = 0.01f;
                    }
                }
            );
            ModAPI.Register(
            new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"),
                    NameOverride = "Knockout Antidote Syringe",
                    NameToOrderByOverride = "!SkittleSyringe6",
                    DescriptionOverride = "Nullifies the effects of the Improved Knockout Syringe",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb/ANTIKNOCK.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<ANTIKNOCKSyringe>();
                        Instance.GetComponent<ANTIKNOCKSyringe>().Finite = true;
                        Instance.GetComponent<ANTIKNOCKSyringe>().TransferRate = 0.01f;
                    }
                }
            );
            ModAPI.Register(
            new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"),
                    NameOverride = "Painkiller Syringe",
                    NameToOrderByOverride = "!SkittleSyringe7",
                    DescriptionOverride = "Never feel pain ever again!",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb/PAINKILL.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<PAINKILLSyringe>();
                        Instance.GetComponent<PAINKILLSyringe>().Finite = true;
                        Instance.GetComponent<PAINKILLSyringe>().TransferRate = 0.01f;
                    }
                }
            );
            ModAPI.Register(
            new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"),
                    NameOverride = "Suffocation Syringe",
                    NameToOrderByOverride = "!SkittleSyringe8",
                    DescriptionOverride = "Stops the lungs from working, slowly taking away oxygen until death",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb/SUFF.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<SUFFSyringe>();
                        Instance.GetComponent<SUFFSyringe>().Finite = true;
                        Instance.GetComponent<SUFFSyringe>().TransferRate = 0.01f;
                    }
                }
            );
            ModAPI.Register(
            new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"),
                    NameOverride = "Waterbreathing Syringe",
                    NameToOrderByOverride = "!SkittleSyringe9",
                    DescriptionOverride = "Grow gills and permanently gain the ability to breathe underwater!",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb/GILLS.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<GILLSyringe>();
                        Instance.GetComponent<GILLSyringe>().Finite = true;
                        Instance.GetComponent<GILLSyringe>().TransferRate = 0.01f;
                    }
                }
            );
            ModAPI.Register(
            new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"),
                    NameOverride = "Zombie Cure Syringe",
                    NameToOrderByOverride = "!SkittleSyringe10",
                    DescriptionOverride = "Stops the zombie virus from spreading in the body",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb/ZCURE.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<ZCURESyringe>();
                        Instance.GetComponent<ZCURESyringe>().Finite = true;
                        Instance.GetComponent<ZCURESyringe>().TransferRate = 0.01f;
                    }
                }
            );
            ModAPI.Register(
            new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"),
                    NameOverride = "Gorseblood Syringe",
                    NameToOrderByOverride = "!SkittleSyringe11",
                    DescriptionOverride = "Gorseblood inside a syringe, not recommended to inject",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb/GORSE.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<GorseSyringe>();
                        Instance.GetComponent<GorseSyringe>().Finite = true;
                        Instance.GetComponent<GorseSyringe>().TransferRate = 0.01f;
                    }
                }
            );
            ModAPI.Register(
            new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"),
                    NameOverride = "Oil Syringe",
                    NameToOrderByOverride = "!SkittleSyringe13",
                    DescriptionOverride = "Not the kind that makes you float, just heavier-than-water oil",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb/OIL.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<OilSyringe>();
                        Instance.GetComponent<OilSyringe>().Finite = true;
                        Instance.GetComponent<OilSyringe>().TransferRate = 0.01f;
                    }
                }
            );
            ModAPI.Register(
            new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"),
                    NameOverride = "Invincibility Syringe",
                    NameToOrderByOverride = "!SkittleSyringe14",
                    DescriptionOverride = "Allows the user to never die",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb/INVINCE.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<InvincibilitySyringe>();
                        Instance.GetComponent<InvincibilitySyringe>().Finite = true;
                        Instance.GetComponent<InvincibilitySyringe>().TransferRate = 0.01f;
                    }
                }
            );
            ModAPI.Register(
            new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"),
                    NameOverride = "Temperature Immunity Syringe",
                    NameToOrderByOverride = "!SkittleSyringe15",
                    DescriptionOverride = "Keeps the user at a constant temperature",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb/TEMP.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<TempSyringe>();
                        Instance.GetComponent<TempSyringe>().Finite = true;
                        Instance.GetComponent<TempSyringe>().TransferRate = 0.01f;
                    }
                }
            );
            ModAPI.Register(
            new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"),
                    NameOverride = "Exotic Liquid Syringe",
                    NameToOrderByOverride = "!SkittleSyringe16",
                    DescriptionOverride = "idk it was added in 1.19.1 not sure what it does",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb/EXOTIC.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<EXOTICSyringe>();
                        Instance.GetComponent<EXOTICSyringe>().Finite = true;
                        Instance.GetComponent<EXOTICSyringe>().TransferRate = 0.01f;
                    }
                }
            );
            ModAPI.Register(
            new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"),
                    NameOverride = "Tritium Syringe",
                    NameToOrderByOverride = "!SkittleSyringe17",
                    DescriptionOverride = "also added in 1.19.1 not sure what it does",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb/TRIT.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<TRITIUMSyringe>();
                        Instance.GetComponent<TRITIUMSyringe>().Finite = true;
                        Instance.GetComponent<TRITIUMSyringe>().TransferRate = 0.01f;
                    }
                }
            );
        }
    }
}
